Package org.apache.jmeter.control.gui

# Class LoopControlPanel

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
org.apache.jmeter.gui.AbstractJMeterGuiComponent
org.apache.jmeter.control.gui.AbstractControllerGui
org.apache.jmeter.control.gui.LoopControlPanel

All Implemented Interfaces:
  `ActionListener`, `ImageObserver`, `MenuContainer`, `Serializable`, `EventListener`, `Accessible`, `ClearGui`, `JMeterGUIComponent`, `Printable`

public class LoopControlPanel extends AbstractControllerGui implements ActionListener
The user interface for a controller which specifies that its subcomponents should be executed some number of times in a loop. This component can be used standalone or embedded into some other component.

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class javax.swing.JPanel

`JPanel.AccessibleJPanel`

## Nested classes/interfaces inherited from class javax.swing.JComponent

`JComponent.AccessibleJComponent`

## Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

### Fields inherited from class org.apache.jmeter.gui.AbstractJMeterGuiComponent

`bindingGroup, namePanel`

### Fields inherited from class javax.swing.JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`LoopControlPanel()`
Create a new LoopControlPanel as a standalone component.
`LoopControlPanel(boolean displayName)`
Create a new LoopControlPanel as either a standalone or an embedded component.

## Method Summary

Modifier and Type
Method
Description
`void`
`actionPerformed(ActionEvent event)`
Invoked when an action occurs.
`void`
`clearGui()`
Implements JMeterGUIComponent.clearGui
`void`
`configure(org.apache.jmeter.testelement.TestElement element)`
A newly created component can be initialized with the contents of a Test Element object by calling this method.
`org.apache.jmeter.testelement.TestElement`
`createTestElement()`
JMeter test components are separated into a model and a GUI representation.
`JCheckBox`
`getInfinite()`
`String`
`getLabelResource()`
Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language.
`JTextField`
`getLoops()`
`JLabel`
`getLoopsLabel()`
`void`
`modifyTestElement(org.apache.jmeter.testelement.TestElement lc)`
GUI components are responsible for populating TestElements they create with the data currently held in the GUI components.

### Methods inherited from class org.apache.jmeter.control.gui.AbstractControllerGui

`createPopupMenu, getMenuCategories`

### Methods inherited from class org.apache.jmeter.gui.AbstractJMeterGuiComponent

`configureTestElement, createTitleLabel, getComment, getDocAnchor, getName, getNamePanel, getPrintableComponent, getStaticLabel, isEnabled, makeBorder, makeScrollPane, makeScrollPane, makeTitlePanel, setComment, setEnabled, setName, wrapTitlePanel`

### Methods inherited from class javax.swing.JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.apache.jmeter.gui.JMeterGUIComponent

`assignDefaultValues, canBeAdded, makeTestElement`

## Constructor Details

### LoopControlPanel

public LoopControlPanel()
Create a new LoopControlPanel as a standalone component.

### LoopControlPanel

public LoopControlPanel(boolean displayName)
Create a new LoopControlPanel as either a standalone or an embedded component.

Parameters:
  `displayName` - indicates whether or not this component should display its name. If true, this is a standalone component. If false, this component is intended to be used as a subpanel for another component.

## Method Details

### getLoopsLabel

@API(status=EXPERIMENTAL) public JLabel getLoopsLabel()

### getInfinite

@API(status=EXPERIMENTAL) public JCheckBox getInfinite()

### getLoops

@API(status=EXPERIMENTAL) public JTextField getLoops()

### configure

public void configure(org.apache.jmeter.testelement.TestElement element)
A newly created component can be initialized with the contents of a Test Element object by calling this method. The component is responsible for querying the Test Element object for the relevant information to display in its GUI.

Specified by:
  `configure` in interface `JMeterGUIComponent`
Overrides:
  `configure` in class `AbstractJMeterGuiComponent`
Parameters:
  `element` - the TestElement to configure

### createTestElement

public org.apache.jmeter.testelement.TestElement createTestElement()
Description copied from interface: `JMeterGUIComponent`
JMeter test components are separated into a model and a GUI representation. The model holds the data and the GUI displays it. The GUI class is responsible for knowing how to create and initialize with data the model class that it knows how to display, and this method is called when new test elements are created.

Since 5.6.3, the default implementation is as follows, and subclasses should override `JMeterGUIComponent.makeTestElement()`

     public TestElement createTestElement() {
         TestElement element = makeTestElement();
         assignDefaultValues(element);
         return el;
     }

Before 5.6.3 the canonical implementation was as follows, however, it is recommended to avoid overriding `JMeterGUIComponent.createTestElement()` and override `JMeterGUIComponent.makeTestElement()` instead.

     public TestElement createTestElement() {
         TestElementXYZ el = new TestElementXYZ();
         modifyTestElement(el);
         return el;
     }

Specified by:
  `createTestElement` in interface `JMeterGUIComponent`
Returns:
  the Test Element object that the GUI component represents.

### modifyTestElement

public void modifyTestElement(org.apache.jmeter.testelement.TestElement lc)
Description copied from interface: `JMeterGUIComponent`
GUI components are responsible for populating TestElements they create with the data currently held in the GUI components. This method should overwrite whatever data is currently in the TestElement as it is called after a user has filled out the form elements in the gui with new information.

If you override `AbstractJMeterGuiComponent`, you might want using `AbstractJMeterGuiComponent.bindingGroup` instead of overriding `modifyTestElement`.

The canonical implementation looks like this:

     @Override
     public void modifyTestElement(TestElement element) {
         super.modifyTestElement(element); // clear the element and assign basic fields like name, gui class, test class
         // Using the element setters (preferred):
         // If the field is empty, you probably want to remove the property instead of storing an empty string
         // See Streamline binding of UI elements to TestElement properties
         // for more details
         TestElementXYZ xyz = (TestElementXYZ) element;
         xyz.setState(StringUtils.defaultIfEmpty(guiState.getText(), null));
         xyz.setCode(StringUtils.defaultIfEmpty(guiCode.getText(), null));
         ... other GUI fields ...
         // or directly (do not use unless there is no setter for the field):
         element.setProperty(TestElementXYZ.STATE, StringUtils.defaultIfEmpty(guiState.getText(), null))
         element.setProperty(TestElementXYZ.CODE, StringUtils.defaultIfEmpty(guiCode.getText(), null))
         ... other GUI fields ...
     }

Specified by:
  `modifyTestElement` in interface `JMeterGUIComponent`
Overrides:
  `modifyTestElement` in class `AbstractJMeterGuiComponent`
Parameters:
  `lc` - the TestElement to modify

### clearGui

public void clearGui()
Implements JMeterGUIComponent.clearGui

Specified by:
  `clearGui` in interface `ClearGui`
Overrides:
  `clearGui` in class `AbstractJMeterGuiComponent`

### actionPerformed

public void actionPerformed(ActionEvent event)
Invoked when an action occurs. This implementation assumes that the target component is the infinite loops checkbox.

Specified by:
  `actionPerformed` in interface `ActionListener`
Parameters:
  `event` - the event that has occurred

### getLabelResource

public String getLabelResource()
Description copied from interface: `JMeterGUIComponent`
Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language. The resource name is fixed, and does not vary with the selected language.

Normally this method should be overridden in preference to overriding getStaticLabel(). However where the resource name is not available or required, getStaticLabel() may be overridden instead.

Specified by:
  `getLabelResource` in interface `JMeterGUIComponent`
Returns:
  the resource name